//obsluha prvku v hlavnim formulari (ne zalozky)
procedure IsSaved;
begin
  if(FormMain_MainCheckChange.checked) then begin
    if(6=MessBox('Pokraovnm budou ztraceny zmny v Template souborech.'+CRLF+CRLF
      +'Uloit zmny?'+CRLF,'Neuloen zmny v nastaven statistiky',4)) then begin
      ShowMessage('... Ulozeni zatim neni implementovano ...');
    end;
  end;
end;

function GetDepthFile(iIndex:Integer):Integer; //vraci pocet zanoreni souboru s danym indexem
begin
  Result:=0;
  while (iIndex>0) do begin
    Result:=Result+1;
    iIndex:=aFiles[iIndex].iParentIndex;
  end;
end;

procedure ShowFiles;    //prepise seznam souboru do listboxu
var i:integer;
begin
  FormMain_MainListFiles.Clear();
  for i:=0 to (naFiles-1) do begin
    aFiles[i].iDepth:=GetDepthFile(i);  //nastavime hloubku zanoreni souboru
    FormMain_MainListFiles.Items.Add(RegexReplace('.*\\',aFiles[i].sPathFile,'',false));
  end;
  FormMain_MainListFiles.ItemIndex:=0;
end;

procedure MainListFilesOnDrawItem(list: TWinControl; Index: Integer; Rect: TRect;
  iState: byte {podle dokumentace je typu TOwnerDrawState, ale v enginu je byte});
var
  Bitmap:TBitmap;
  RectSrc,RectTrg:TRect;
  x,y:integer;
  i:integer;
begin
  if(Index>=0) then begin
    with FormMain_MainListFiles.Canvas do begin
      if((iState AND 1)=1) then Brush.Color:=STYLE_BKGCOLOR_SELECTED
      else Brush.Color:=STYLE_BKGCOLOR_FOCUSED;
      FillRect(Rect);
      i:=12*aFiles[Index].iDepth;
      if(aFiles[Index].bChange) then begin
        //if((iState AND 1)=1) then Bitmap:=aBitmap[ICON_CHANGE_SELECTED]
        //else Bitmap:=aBitmap[ICON_CHANGE];
        Bitmap:=aBitmap[ICON_CHANGE];
        RectSrc.Left:=0; RectSrc.Top:=0; RectSrc.Right:=Bitmap.Width; RectSrc.Bottom:=Bitmap.Height;
        RectTrg.Left:=Rect.Left+2+i; RectTrg.Top:=Rect.Top+3;
        RectTrg.Right:=Rect.Left+2+i+Bitmap.Width; RectTrg.Bottom:=Rect.Top+3+Bitmap.Height;
        BrushCopy(RectTrg,Bitmap,RectSrc,Bitmap.Canvas.Pixels[0,0]);	// zkopirovat bitmapu do Canvasu
        x:=Bitmap.Width;
        y:=Bitmap.Height;
      end
      else begin x:=9; y:=9; end;
      TextOut(Rect.Left+(x+6)+i,Rect.Top,FormMain_MainListFiles.Items[Index]);
    end;
  end;
end;

procedure ReadTemplate(sPath:string);
begin
    GeoBusyKind('Cteni template souboru ...');
    FreeVars(false); //uvolnit pamet pouzivanou jen pro Template soubor
    FormMain_MainEditFile.Hint:=sPath; // v hintu bude plne jmeno a cesta
    FormMain_MainEditFile.Text:=RegexReplace('.*\\',sPath,'',false); // v okne jen samotne jmeno
    naFiles:=1;                  //
    aFiles[0].sPathFile:=sPath;
    aFiles[0].sCommand:='';
    aFiles[0].iParentIndex:=-1;
    aFiles[0].bChange:=false;
    ParseTemplate(sPath,naFiles-1);   //nacteme prikazy 1. template souboru
    MarkGroupCmds();  //rozeznat, ulozit, oznacit a preorganizovat skupinove prikazy
    iActualParseFile:=-1;             //zadny nezpracovavany soubor
    FormMain_UvodListTemplate.ItemIndex:=-1;
    ShowFiles();                      //zobrazime seznam souboru, ktere jsou v Template pouzivany
    CmdToList();                      //zobrazit seznam prikazu
    ColorsetCopyToList();
    NumbersToList();
    SetProgressBar(0,1,'');
    UvodListTemplateOnClick(nil); //kliknuti na aktivi polozku v seznamu
    ShowPage(FormMain_Pages,'TabUvod');   //zobrazit spravnou zalozku, (aktualni muze byt treba editace)
    EnableButtons();
end;

procedure MainButFileOnClick(sender:TObject);
var
  sPath:string;
begin
  IsSaved();
  if(OpenDlg('Vbr souboru s hlavn ablonou',       //title
             GetGgStatDir(),             //InitDir
             'ofFileMustExist,ofHideReadOnly', //options
             'Template soubory (*.cz, *.en, *.cfg)|*.cz;*.en;*.cfg|'
            +'Vechny soubory (*.*)|*.*',   //filtry pro ruzne soubory
             sPath)) then begin
    ReadTemplate(sPath);
  end;
end;

procedure MainButPreviewOnClick(sender:TObject);
var i:Integer;
  b:boolean;
  x,y:extended;
  sPath:string;
  ini:TIniFile;
begin
  IsSaved();
  //zkusime souradnice nacist z Autostatu
  ini:=TIniFile.Create(GetAutostatDir()+'\Autostat.ini');
  x:=0; y:=0;
  if(ini<>nil) then begin
    x:=StrToFloat(ini.ReadString('AutoStat','HomeLat','0'));
    y:=StrToFloat(ini.ReadString('AutoStat','HomeLon','0'));
    ini.Free();
  end;
  //pokud neni z ini, zkusime jako referencni bod
  if(x=0) or (y=0) then begin
    b:=RefPointGet('HOME',x,y);
  end;
  //pokud neexistuje
  sPath:=
    +'"'+GetGgStatDir()+'\GgStat.exe"'{+' -q'}
    +' -d "'+GEOGET_DATADIR+'\'+GEOGET_DBNAME+'.db3"'
    +' -c "'+GEOGET_OWNER+'"'
    +' -o "'+GetMainDir()+'\'+TMP_HTML_FILE+'"'
    +' -t "'+aFiles[0].sPathFile+'"'
    +' -x '+FlToStr(x)+' -y '+FlToStr(y)
    ;
  i:=RunExec(sPath);
  if(i<>0) then ShowMessage('Chyba spusteni GgStat.exe: '+IntToStr(i))
  else RunShell('"'+GetMainDir()+'\'+TMP_HTML_FILE+'"');
end;

procedure MainListFilesOnClick(sender:TObject);
var tList:TListBox;
    i,j:integer;
begin
  //zmenime Hint na prikaz a plnou plnou cestu
  tList:=(sender as TListBox);
  if(tList.ItemIndex>-1) then
    tList.Hint:='poad: '+IntToStr(tList.ItemIndex)+CRLF
      +'index nadzenho: '+IntToStr(aFiles[tList.ItemIndex].iParentIndex)+CRLF
      +'hloubka zanoen: '+IntToStr(GetDepthFile(tList.ItemIndex))+CRLF
      +'neulozena zmena v souboru (0/1): '+IntToStr(aFiles[tList.ItemIndex].bChange as Integer)+CRLF
      +aFiles[tList.ItemIndex].sCommand+' '+aFiles[tList.ItemIndex].sPathFile
  else tList.Hint:='';
  //pokud maji byt zobrazny jen prikazy jedineho souboru, zobrazime je
  if(FormMain_UvodCheckSoubor.checked) then CmdToList()
  else begin //jinak skocime na prvni zobrazeny prikaz vybraneho souboru
             //(pokud neni, tak nechame byt)
    j:=0;
    for i:=0 to FormMain_UvodListTemplate.Items.Count-1 do begin
      if(aCommand[aIndexCommand[i]].iFile=tList.ItemIndex) then begin
        FormMain_UvodListTemplate.ItemIndex:=i;
        UvodListTemplateOnClick(nil); //kliknuti na aktivi polozku v seznamu
        CenterSelectedTemplate;
        i:=FormMain_UvodListTemplate.Items.Count-1;
        j:=1;
        //ShowMessage('Chybne neskace na prvni prikaz z daneho souboru');
      end;
    end;
    if(j=0) then begin
      //jen prikaz INCLUDE_TEMPLATE vklada sablonu, ostatni nemohou obsahovat
      //prikazy GgStatu
      if(aFiles[tList.ItemIndex].sCommand='INCLUDE_TEMPLATE') then
        ShowMessage('Zobrazen pkaz tohoto souboru je potlaeno '+CRLF
         +'(pslun INCLUDE_TEMPLATE nen rozbalen).')
      else ShowMessage('Soubor neobsahuje pkazy GgStatu.');
    end;
  end;
end;

function InsertTuneInit:string;
var i:Integer;
begin
  //vraci pocatek sablony s ulozenymi barvami
  Result:=
     TXT_MYCOMMENT+'----------------- Zacatek vlozene casti pro GgStatTune.'+CRLF
    +TXT_MYCOMMENT+'Soubor je generovan automaticky pluginem GgStatTune.'+CRLF
    +TXT_MYCOMMENT+'Neupravujte nasledujici cast, obsahuje prikazy, ktere zjednodusuji'+CRLF
    +TXT_MYCOMMENT+'zpracovani souboru pluginem.'+CRLF
    +TXT_MYCOMMENT+CRLF
    +TXT_MYCOMMENT+'Definice pojmenovanych barevnych profilu:'+CRLF
    ;
  for i:=0 to naColorset-1 do begin
    //if(aColorset[i].iReferences>0) then begin
      Result:=Result+'#==#_COLORSET '
        +ReplaceString(aColorset[i].sName,' ','_')+' '+'COLORS '+  //zmizet mezery
        +ReplaceString(aColorset[i].sColors,CRLF,' ')+CRLF; //barvy oddelit mezerama
    //end;
  end;
  Result:=Result
    +TXT_MYCOMMENT+CRLF
    +TXT_MYCOMMENT+'----------------- Konec vlozene casti.'+CRLF
    +TXT_MYCOMMENT+CRLF;
end;

function InsertTuneTags(str:string):string;
var i:Integer;
begin
  Result:=str+TXT_MYCOMMENT+'----------------- Seznam definovanych uzivatelskych tagu'+CRLF;
  for i:=0 to naTag-1 do begin
    Result:=Result
      +'DEFINETAG '+ReplaceString(aTag[i].sNameGgs,' ','_')+' '  //zmizet mezery
      +aTag[i].sCategory+CRLF
      +'LANG_TAG_'+ReplaceString(aTag[i].sNameGgs,' ','_')+' '
      +aTag[i].sNameColumn+CRLF;
  end;
  Result:=Result+TXT_MYCOMMENT+'----------------- Konec definovanych uzivatelskych tagu'+CRLF;
end;

function InsertTuneNumber(sName:string):string;
var i:integer;
begin
  Result:='';
  i:=FindIndexNumbersFromName(sName);
  if(i>-1) then begin
    Result:=Result+'LANG_NUMBERS_'+aNumbers[i+1]+' '+aNumbers[i+2]+CRLF;
    Result:=Result+'LANG_NUMBERS_'+aNumbers[i+3]+' '+aNumbers[i+4]+CRLF;
    Result:=Result+'DEFINENUMBERS '+aNumbers[i]+' '+aNumbers[i+1]+' '+aNumbers[i+3]+CRLF;
  end;
end;

procedure Save(new:boolean);
var sPath,s:string;
    i,j,iStartFile:Integer;
begin
  if(new) then begin
    if(not SaveDlg('Uloen nov ablony',       //title
      GetGgStatDir(),             //InitDir
      'ofOverwritePrompt,ofHideReadOnly', //options (ofOwrwrite asi nefunguje)
      'Template soubory (*.cz, *.en, *.cfg)|*.cz;*.en;*.cfg|'
      +'Vechny soubory (*.*)|*.*',   //filtry pro ruzne soubory
      sPath)) then exit;
    aFiles[0].sPathFile:=sPath;
    aFiles[0].bChange:=true;
    naFiles:=1;
  end;
  //zjistime, v kterem souboru je START, abychom vedeli, kam vlozit TAGy
  iStartFile:=-1;
  if(iStartCmd>=0) then iStartFile:=aCommand[iStartCmd].iFile;
  for i:=0 to naFiles-1 do begin //do kazdeho souboru jen jeho prikazy
    if(aFiles[0].bChange) then begin  //a jen pokud je zmenen
      s:='';
      //pokud je to prvni soubor, ulozime definici barev a pred start (nebo
      //na konec souboru, pokud tam START neni) ulozime definici TAGu
      if(i=0) then s:=s+InsertTuneInit();
      SetProgressBar(0,naCommand-1,RegexReplace('.*\\',aFiles[0].sPathFile,'',false));
      for j:=0 to naCommand-1 do begin
        FormMain_MainProgress.Position:=j;
        if((iStartFile=i) and (j=iStartCmd))
          or ((iStartFile=-1) and (i=0) and (j=0)) then begin
          s:=InsertTuneTags(s);
          s:=s+TXT_MYCOMMENT+CRLF
            +TXT_MYCOMMENT+'----------------- Zacatek prezentacni casti sablony'+CRLF
            +TXT_MYCOMMENT+CRLF;
        end;
        if(aCommand[j].iFile=i) or (new) then begin //zapsat prikaz
          //pred definici radku zajimavych cisel musime zapsat definici sloupcu
          if(aCmdPar[aCommand[j].iCmdPar].sCommand='APPEND_NUMBERS') then
            s:=s+InsertTuneNumber(aCommand[j].sParam);
          //nezapisujeme striktne interni prikazy, ale nerozpoznane (tedy
          //i prazdne radky) ano
          if(aCmdPar[aCommand[j].iCmdPar].sCategory<>'internal')
            or (aCommand[j].bPlugin)
            or (aCmdPar[aCommand[j].iCmdPar].sCommand='_neznamy_')
            then begin //prazdny prikaz je komentar, ten take vezmeme
            //prikazy pluginu pro prehlednost odsadime
            if(aCommand[j].bPlugin) then s:=s+TXT_PLUGIN_AUTOINDENT;
            if(aCommand[j].sCommand='COLORS') then
              aCommand[j].sParam:=ReplaceString(GetColorsetFromName(aCommand[j].sParam),CRLF,' ');
            s:=s+Trim(aCommand[j].sCommand+' '+aCommand[j].sParam)+CRLF;
          end;
        end;
      end;
      //ulozime ve spravnem kodovani
      if(sIncoding<>'cp1250') then s:=UtfToCharset(AnsiToUtf(s),sIncoding);
      StringToFile(s,aFiles[i].sPathFile);
    end;
  end;
  //zmeny jsou ulozeny
  if(new) then ReadTemplate(sPath) //nacist znovu, aby byly spravne soubory, ...
  else FormMain_MainCheckChange.checked:=false;
end;

procedure MainButSaveOnClick(sender:TObject);
begin Save(false); end;

procedure MainButSaveAsOnClick(sender:TObject);
begin Save(true); end;

function StrToList(str:string):TStringList;
var s,s1:string;
begin
  Result:=TStringList.Create();
  while str<>'' do begin
    s:=Trim(fetch(str,CRLF));
    if(copy(s,1,1)=';') then s:='';
    if((Result.Count=0) and (pos(']',s)>0)) then s1:=s  //aby pomocne interni prikazy mohly zacinat '#'
    else s1:=Trim(fetch(s,'#'));
    if(s1<>'') then Result.Add(s1);
  end;
end;

procedure ReadColorType(lst:TStringList); //naplni seznam fontu pro zobrazovani prikazu v listboxu
var i:Integer;
    s,s1:string;
    a:TStringList;
begin
  naFontItem:=0;
  for i:=0 to lst.Count-1 do begin
    a:=StrToList(ReplaceString(lst.Strings[i],',',CRLF));
    if((a.Strings[0]<>'') and (a.count>=3)) then begin
      s:=a.Strings[0];
      s1:=fetch(s,'=');
      aFontItem[naFontItem].sName:=s1;
      aFontItem[naFontItem].iId:=StrToInt(s);
      aFontItem[naFontItem].rFont.iColor:=StrToInt('$'+a[1]);
      aFontItem[naFontItem].rFont.iBkgColor:=StrToInt('$'+a[2]);
      aFontItem[naFontItem].rFont.iIndex:=a.count;
      if(a.count>3) then begin
        if(RegexFind('Bold',a[3])) then
          aFontItem[naFontItem].rFont.iFontStyle:=[fsBold];
        if(RegexFind('Italic',a[3])) then
          aFontItem[naFontItem].rFont.iFontStyle:=aFontItem[naFontItem].rFont.iFontStyle+[fsItalic];
      end;
      naFontItem:=naFontItem+1;
    end;
    a.Free;
  end;
end;

function DuplicateStringList(list:TStringList;max:integer;impl:string):TStringList;
var i:integer;     //rozmnozi StringList na poslednim miste na zadany pocet prku
    s:string;
begin
  if(list=nil) then Result:=TStringList.Create()
  else Result:=list;
  i:=Result.Count;
  if(i<=0) then s:=impl
  else s:=Result.strings[i-1];
  for i:=i to max do Result.Add(s);
end;

procedure ReadCmdPar(lst:TStringList); //nacte a ulozi parametry prikazu z INI souboru
var i,j:integer;
    cmd,s,s1:string;
begin
  if(naCmdPar>=MAX_CMDPARAM) then begin
    ShowMessage('ERROR: Prekroen poet pkaz natench z INI souboru!');
    GeoAbort();
  end;
  if(lst.Count<=0) then begin
    // ShowMessage('ERROR-INI: Prazdny seznam parametru prikazu, neuveden prikaz');
  end
  else begin
    aCmdPar[naCmdPar].iParams[0]:=-1;
    s:=lst.Strings[0];
    cmd:=fetch(s,']');
    j:=1;
    for i:=1 to lst.Count-1 do begin
      s1:=lst.Strings[i];
      s:=fetch(s1,'=');
      if(s='Comment') then aCmdPar[naCmdPar].sComment:=s1
      else if(s='Short') then aCmdPar[naCmdPar].sShort:=s1
      else if(s='Type') then aCmdPar[naCmdPar].sType:=s1
      else if(s='Category') then aCmdPar[naCmdPar].sCategory:=s1
      //else if(s='Block') then aCmdPar[naCmdPar].sBlock:=s1
      else if(s='Elements') then aCmdPar[naCmdPar].sElements:=s1
      else if(s='Params') then begin
        aCmdPar[naCmdPar].iParams[0]:=StrToInt(fetch(s1,','));
        if(s1<>'') then aCmdPar[naCmdPar].iParams[1]:=StrToInt(s1)
        else aCmdPar[naCmdPar].iParams[1]:=aCmdPar[naCmdPar].iParams[0];
      end
      else if(s='ParamTypes') then aCmdPar[naCmdPar].aParamTypes:=StrToList(ReplaceString(s1,',',CRLF))
      else if(s='ParamNames') then aCmdPar[naCmdPar].aParamNames:=StrToList(ReplaceString(s1,'|',CRLF))
      else if(s='GsVariables') then aCmdPar[naCmdPar].sGsVariables:=s1
      else if(s='Values') then aCmdPar[naCmdPar].aValues:=StrToList(ReplaceString(s1,'|',CRLF))
      else if(s='Doc') then aCmdPar[naCmdPar].sDoc:=s1
      else if(s='Demo') then aCmdPar[naCmdPar].sDemo:=s1
      else begin
        ShowMessage('ERROR-INI: Chybna definice prikazu:'+CRLF
          +'Poradi: '+IntToStr(naCmdPar)+CRLF
          +'Prikaz: '+cmd+CRLF
          +'Parametr: '+s+'='+s1);
        j:=2; //chyba v definici, prikaz vynechame
      end;
    end;
    //kontrola zadanych hodnot
    if(cmd='') then j:=3;
    if((aCmdPar[naCmdPar].sType='') or (aCmdPar[naCmdPar].sCategory='')
      or (aCmdPar[naCmdPar].iParams[0]<0)) then begin
      ShowMessage('ERROR-INI: Chybna definice prikazu:'+CRLF
        +'Prikaz: '+cmd+CRLF
        +'Chybi parametr Type, Category nebo Params');
      j:=4;
    end;
    //typy parametru a jmena parametru rozmnozime zopakovanim posledniho
    if(aCmdPar[naCmdPar].iParams[1]>0) then begin
      aCmdPar[naCmdPar].aParamTypes:=DuplicateStringList(aCmdPar[naCmdPar].aParamTypes,aCmdPar[naCmdPar].iParams[1]-1,'???'{'string'});
      aCmdPar[naCmdPar].aParamNames:=DuplicateStringList(aCmdPar[naCmdPar].aParamNames,aCmdPar[naCmdPar].iParams[1]-1,'??? Nepojmenovno v INI ???');
      aCmdPar[naCmdPar].aValues:=DuplicateStringList(aCmdPar[naCmdPar].aValues,aCmdPar[naCmdPar].iParams[1]-1,'');
    end;
    //pokud je to mozne, ulozime prikaz
    if(j=1) then begin
      aCmdPar[naCmdPar].sCommand:=cmd;
      naCmdPar:=naCmdPar+1;
    end;
  end;
end;

procedure ReadCategories; //naplni pole stringu prikazu podle kategorii,
var i,j,ind:integer;          //aby se zobrazily pro vybranem radiobuttonu jen ty spravne
    a:TStringList;
    //s:string;
begin
  if(aCategory.Count>=MAX_CATEGORY) then begin
    ShowMessage('ERROR: Prekrocen maximalni pocet kategori.');
    GeoAbort();
  end;
  //inicializovat pole prikazu, pro kazdou kategori jeden TStringList
  for j:=0 to aCategory.Count-1 do begin
    aListboxCat[j]:=TStringList.Create();
  end;
  //rozhazime prikazy podle kategorii do spravnych stringlistu
  for i:=0 to naCmdPar-1 do begin
    a:=StrToList(ReplaceString(aCmdPar[i].sCategory,',',CRLF));
    for j:=0 to a.Count-1 do begin
      ind:=aCategory.IndexOfName(a.Strings[j]);
      if(ind<0) then ShowMessage('ERROR: INI soubor, prikaz: '+aCmdPar[i].sCommand+CRLF
        +'Neznama kategorie: '+a.Strings[j])
      else begin
        aListboxCat[ind].Add(aCmdPar[i].sCommand);
      end;
    end;
    a.Free;
  end;
end;

procedure ReadIni;
var s,sekce:string;
    i,j:Integer;
begin
  s:=FileToString(GetMainDir+'\GgStatTune.CmdPar.ini');
  i:=0;
  while(s<>'') do begin
    sekce:=fetch(s,CRLF+'[');
    if(RegexFind('^[\[]*TYPE[\]]',sekce)) then ReadColorType(StrToList(sekce))
    else if(RegexFind('^[\[]*CATEGORY[\]]',sekce)) then aCategory:=StrToList(sekce)
    else {if(naCmdPar<5) then} ReadCmdPar(StrToList(sekce));  //nacteme parametry prikazu
    ; //ostatni zatim ignorujeme
  end;
  //vytvorime radiobuttony se seznamem kategorii
  FormMain_UvodRadioCat.Items.Clear();
  aCategory.Delete(0); //vymazat jmeno sekce z INI souboru
  for i:=0 to aCategory.Count-1 do begin
    s:=aCategory.Strings[i];
    sekce:=fetch(s,'='); //nechame jen text pro zobrazeni
    //nezobrazovat interni kategorii (zacina podtrzitkem)
    if(bDebug) or (sekce<>'internal') then FormMain_UvodRadioCat.Items.Add(Trim(s));
  end;
  FormMain_UvodRadioCat.ItemIndex:=0; //zvolime prvni kategorii
  //prepiseme nactene prikazy do poli podle kategorii
  ReadCategories();
  //prepiseme promenne do listboxu pro editaci polozky
  i:=aCategory.IndexOfName('VAR');
  if(i>=0) then begin
    FormMain_EditListVars.Items:=aListboxCat[i];
    for i:=0 to FormMain_EditListVars.Items.Count-1 do begin
      j:=FindIndexCmdParFromCmd(FormMain_EditListVars.Items[i]);
      if(j>=0) then begin
        FormMain_EditListVars.Items[i]:=FormMain_EditListVars.Items[i]
          +CMT_SEPARATOR+aCmdPar[j].sComment;
        //plnime zaroven seznam v zalozce pro definici Zajimavych cisel
        FormMain_NumbersListVars.Items.Add(FormMain_EditListVars.Items[i]);
      end;
    end;
  end;
end;

procedure FormOnClose(Sender: TObject; var Action: TCloseAction); //uvolnime alokovanou pamet
begin
  IsSaved();
  FreeVars(true);
end;

procedure GetAutostatTemplate;
var s,s1:string;
    a:TStringList;
    i:integer;
begin
  s:=GEOGET_SCRIPTDIR+'\Autostat\Autostat.ini';
  if(FileExists(s)) then begin
    a:=TStringList.Create;
    a.LoadFromFile(s);
    i:=a.IndexOfName('Template');
    if(i>=0) then begin
      s:=a[i];
      s1:=fetch(s,'=');
      s1:=RelToAbsFilename(s,GetGgStatDir);
      if(not FileExists(s1)) then begin //pokud neni, zkusime ho v DATADIR
        s1:=RelToAbsFilename(s,GEOGET_DATADIR);
      end;
      if(FileExists(s1)) then begin //predame soubor k otevreni
        ReadTemplate(s1);
      end;
    end;
    a.Free;
  end;
end;

procedure ResizeMain(sender:TObject);
var x,x1,y:Integer;
begin
  x:=FormMain.ClientWidth;
  y:=FormMain.ClientHeight;
  //ShowMessage('UUUUU x:='+IntToStr(x)+', y='+IntToStr(y));
  if(x<684) then begin x:=684; FormMain.ClientWidth:=x; end;
  if(y<601) then begin y:=601; FormMain.ClientHeight:=y; end;
  x1:=(x-64)/2;
  FormMain_Pages.Width:=x-3;
  FormMain_Pages.Height:=y-104-32;
  FormMain_MainCheckChange.Top:=y-36;
  FormMain_MainProgress.Top:=y-33;
  FormMain_MainLabelProgress.Top:=y-50;
  FormMain_MainButSave.Top:=y-33;
  FormMain_MainButExit.Top:=y-33;
  FormMain_MainEditFile.Width:=x-291;
  FormMain_MainLabelFiles.Left:=x-388;
  FormMain_MainListFiles.Left:=x-282;
  FormMain_MainProgress.Width:=x-308;
  FormMain_MainButSave.Left:=x-160;
  FormMain_MainButExit.Left:=FormMain_MainButSave.Left+80;
  FormMain_MainButSaveAs.Left:=FormMain_MainButSave.Left;
  FormMain_MainButPreview.Left:=FormMain_MainButExit.Left;
  FormMain_MainButSaveAs.Top:=FormMain_MainButExit.Top-32;
  FormMain_MainButPreview.Top:=FormMain_MainButExit.Top-32;
  //nasledujici jsou relativne vuci Pages
  y:=y-32;
  FormMain_UvodCheckSoubor.Top:=y-172;
  FormMain_UvodCheckKomentar.Top:=y-154;
  FormMain_UvodCheckInit.Top:=y-172;
  FormMain_UvodButDoc.Top:=y-170;
  FormMain_UvodButDemo.Top:=y-170;
  FormMain_UvodListTemplate.Height:=y-180;
  FormMain_UvodListMozne.Height:=y-284;
  FormMain_UvodListTemplate.Width:=x1;
  FormMain_UvodListMozne.Width:=x1;
  FormMain_UvodListMozne.Left:=x1+49;
  FormMain_UvodRadioCat.Width:=FormMain_UvodListMozne.Width;
  FormMain_UvodRadioCat.Left:=FormMain_UvodListMozne.Left;
  FormMain_UvodButExpand.Left:=x1+12;
  FormMain_UvodButClose.Left:=x1+27;
  FormMain_UvodButFind.Left:=FormMain_UvodButExpand.Left;
  FormMain_UvodButFindNext.Left:=FormMain_UvodButExpand.Left;
  FormMain_UvodButAdd.Left:=FormMain_UvodButExpand.Left;
  FormMain_UvodButDel.Left:=FormMain_UvodButExpand.Left;
  FormMain_UvodButUp.Left:=FormMain_UvodButExpand.Left;
  FormMain_UvodButDown.Left:=FormMain_UvodButExpand.Left;
  FormMain_UvodButEdit.Left:=FormMain_UvodButExpand.Left;
  FormMain_UvodButComment.Left:=FormMain_UvodButExpand.Left;
  //ResizeNumbers();
  FormMain_NumbersListVars.Width:=x-311;
  FormMain_NumbersListVars.Height:=y-432;
  FormMain_NumbersEditName.Width:=x-403;
  FormMain_NumbersEditNameLeft.Width:=x-451;
  FormMain_NumbersEditContentLeft.Width:=FormMain_NumbersEditNameLeft.Width;
  FormMain_NumbersEditNameRight.Width:=FormMain_NumbersEditNameLeft.Width;
  FormMain_NumbersEditContentRight.Width:=FormMain_NumbersEditNameLeft.Width;
  FormMain_NumbersButAddLeft.Top:=y-256;
  FormMain_NumbersButAddRight.Top:=FormMain_NumbersButAddLeft.Top;
  FormMain_NumbersButAddRight.Left:=x-97;
  FormMain_NumbersLabelNote.Top:=y-228;
  FormMain_NumbersLabelNote.Width:=x-322;
  FormMain_NumbersButChange.Top:=y-171;
  FormMain_NumbersButAdd.Top:=FormMain_NumbersButChange.Top;
  FormMain_NumbersButDel.Top:=FormMain_NumbersButChange.Top;
  FormMain_NumbersButDel.Left:=445+(x-445-239)/2;
  FormMain_NumbersButAdd.Left:=FormMain_NumbersButDel.Left+88;
  FormMain_NumbersButChange.Left:=FormMain_NumbersButDel.Left-88;
  //ResizeColors();
  //ResizeTag();
  FormMain_EditPagesParam.Width:=x-311;
  FormMain_EditListVars.Height:=y-368;
  FormMain_EditListParam.Height:=y-224;
  FormMain_EditButUse.Top:=y-162;
  FormMain_EditButCancel.Top:=FormMain_EditButUse.Top;
  FormMain_EditButUseParam.Width:=x-311;
  FormMain_EditListVars.Width:=x-315;
  FormMain_EditFileEditFile.Width:=x-363;
  FormMain_EditFileButFile.Left:=x-354;
  FormMain_EditEnumListEnum.Width:=x-334;
  FormMain_EditCacheListCache.Width:=FormMain_EditEnumListEnum.Width;
  FormMain_EditCacheidEditCacheid.Width:=x-327;
  FormMain_EditRealEditReal.Width:=FormMain_EditCacheidEditCacheid.Width;
  FormMain_EditIntEditInt.Width:=FormMain_EditCacheidEditCacheid.Width;
  FormMain_EditTextEditText.Width:=FormMain_EditCacheidEditCacheid.Width;
  FormMain_EditWordEditWord.Width:=FormMain_EditCacheidEditCacheid.Width;
end;

procedure InitMain; begin
  GeoBusyKind('Inicializace ...');
  SetProgressBar(0,1,'');
  bDebug:=(GEOGET_OWNER='gordici');

  FormMain.Caption:=FormMain.Caption+' (verze '
    +GeoGetPackageVersion(GetMainDir()+'\GgStatTune.meta.ini')+')';

  //upravit vysku a sirku, aby nebyl vpravo a dole tak velky volny prostor
  //(je to asi zpusobeno jinym fontem nez je pouzit v navfrhu formulare)
  FormMain.Width:=FormMain.Width-16;
  FormMain.Height:=FormMain.Height-12;
  FormMain_MainButSave.Enabled:=false;
  //nastavime obsluhy jednotlivym tlacitkum
  FormMain_MainListFiles.OnDrawItem:=@MainListFilesOnDrawItem;
  
  FormMain_MainButFile.OnClick:=@MainButFileOnClick;
  //FormMain_MainListFiles.OnDblClick:=;
  FormMain_MainListFiles.OnClick:=@MainListFilesOnClick;
  FormMain_MainButSave.OnClick:=@MainButSaveOnClick;
  FormMain_MainButSaveAs.OnClick:=@MainButSaveAsOnClick;
  FormMain_MainButPreview.OnClick:=@MainButPreviewOnClick;
  FormMain.OnClose:=@FormOnClose;
  FormMain.BorderStyle:=bsSizeable;
  FormMain.OnResize:=@ResizeMain;
  ReadIni(); //nacteni INI souboru s vlastnostmi prikazu pouzitelnych v Template
  InitUvod(); //nacteni bitmap pro rozbalovatko a zabalovatko seznamu
  InitTag();  //nastavit obsluhu tlacitek na zalozce TAGu
  InitNumbers(); //nastavit obsluhu tlacitek na zalozce zajimavych cisel
  InitColor(); //nastavit obsluhu tlacitek v zalozce barev
  
  //vyvolame kliknuti na radiobutton, aby se zobrazil spravny seznam prikazu
  UvodRadioCatOnClick(nil);
  if(not bDebug) then //u mne se nenacita automaticky
    GetAutostatTemplate();   //zkusime nacist template nastaveny v autostatu
  GeoBusyKind('Dialog ...');
end;
