//obluha TAGu
var bTagDefineChange,bTagNameChange:boolean;

procedure TagEnableButtons;
begin
  FormMain_TagButCat.Enabled:=(FormMain_TagListCategory.ItemIndex>-1);
  FormMain_TagButUpdate.Enabled:=((bTagDefineChange) and (FormMain_TagListTag.ItemIndex>-1));
  FormMain_TagButAdd.Enabled:=(bTagNameChange);
  FormMain_TagButDel.Enabled:=(FormMain_TagListTag.ItemIndex>-1);
end;

procedure TagOnChange(sender:TObject);
begin
  bTagDefineChange:=true;
  TagEnableButtons();
end;

procedure TagNoChange;
begin
  bTagNameChange:=false;
  bTagDefineChange:=false;
  TagEnableButtons();
end;

procedure TagEditGgsOnChange(sender:TObject);
begin
  bTagNameChange:=true;
  TagOnChange(nil);
end;

procedure TagListCategoryOnClick(sender:TObject);
begin
  TagEnableButtons();
end;

procedure GetGGTagCategories;
var tab: TSqliteTable;
begin
  tab:=Geoget_DB.GetTable('select value from geotagcategory gtc ORDER BY gtc.value',false);
  try
    while not tab.eof do begin
      FormMain_TagListCategory.Items.Add(UtfToAnsi(tab.FieldAsString(0)));
      tab.next;                   // skok na dalsi
    end;
  finally tab.free;
  end;
end;

function TagIndexByName(sName:string):integer;
var i:Integer;
begin
  Result:=-1;
  for i:=0 to naTag-1 do begin
    if(aTag[i].sNameGgs=sName) then begin Result:=i; i:=naTag-1; end;
  end;
end;

procedure TagAdd(sNameGgs,sCategory,sNameColumn:string);
var i:Integer;
begin
  sNameGgs:=Trim(sNameGgs);
  sCategory:=Trim(sCategory);
  sNameColumn:=Trim(sNameColumn);
  if(naTag>=MAX_TAG) then ShowMessage('ERROR: Pekroen poet TAG')
  else begin
    if(sNameGgs='') then ShowMessage('ERROR: Chybn definice TAGu, jeden z etz je przdn')
    else begin
      i:=TagIndexByName(sNameGgs);
      if(i=-1) then begin
        i:=naTag;
        naTag:=naTag+1;
        aTag[i].sCategory:='';
        aTag[i].sNameGgs:='';
        aTag[i].sNameColumn:='';
      end;
      if(sCategory<>'') then aTag[i].sCategory:=sCategory;
      if(sNameGgs<>'') then aTag[i].sNameGgs:=sNameGgs;
      if(sNameColumn<>'') then aTag[i].sNameColumn:=sNameColumn;
    end;
  end;
end;

procedure TagListTagOnClick(sender:TObject);
begin
  if(FormMain_TagListTag.ItemIndex>-1) then begin
    FormMain_TagEditCategory.Text:=aTag[FormMain_TagListTag.ItemIndex].sCategory;
    FormMain_TagEditGgs.Text:=aTag[FormMain_TagListTag.ItemIndex].sNameGgs;
    FormMain_TagEditColumn.Text:=aTag[FormMain_TagListTag.ItemIndex].sNameColumn;
  end
  else begin
    FormMain_TagEditCategory.Text:='';
    FormMain_TagEditGgs.Text:='';
    FormMain_TagEditColumn.Text:='';
  end;
  TagNoChange();
end;

procedure TagToList;  //prepise seznam definovanych TAGu do ListBoxu
var i:integer;
begin
  FormMain_TagListTag.Clear();
  for i:=0 to naTag-1 do begin
    FormMain_TagListTag.Items.Add(aTag[i].sNameGgs);
  end;
  if(naTag>0) then begin
    FormMain_TagListTag.ItemIndex:=0;
    TagListTagOnClick(nil);
  end;
end;

procedure TagButCatOnClick(sender:TObject);
begin
  if(FormMain_TagListCategory.ItemIndex>-1) then begin
    FormMain_TagEditCategory.Text:=FormMain_TagListCategory.Items[FormMain_TagListCategory.ItemIndex];
  end;
end;

procedure TagButAddOnClick(sender:TObject);
begin
  aTag[naTag].sCategory:=FormMain_TagEditCategory.Text;
  aTag[naTag].sNameGgs:=FormMain_TagEditGgs.Text;
  aTag[naTag].sNameColumn:=FormMain_TagEditColumn.Text;
  FormMain_TagListTag.Items.Add(FormMain_TagEditGgs.Text);
  FormMain_TagListTag.ItemIndex:=FormMain_TagListTag.Items.Count-1;
  naTag:=naTag+1;
  TagListTagOnClick(nil);
  //OnFileChange(); //problem: nevim, v kterem souboru je TAG pouzit/definovan
end;

procedure TagButDelOnClick(sender:TObject);
var i:integer;
begin
  if(FormMain_TagListTag.ItemIndex>-1) then begin
    for i:=FormMain_TagListTag.ItemIndex to naTag-2 do aTag[i]:=aTag[i+1];
    naTag:=naTag-1;
    i:=FormMain_TagListTag.ItemIndex;
    FormMain_TagListTag.Items.Delete(FormMain_TagListTag.ItemIndex);
    if(i>=FormMain_TagListTag.Items.Count) then i:=i-1;
    FormMain_TagListTag.ItemIndex:=i;
    TagListTagOnClick(nil);
    //OnFileChange(); //problem: nevim, v kterem souboru je TAG pouzit/definovan
  end;
end;

procedure TagButUpdateOnClick(sender:TObject);
begin
  if(FormMain_TagListTag.ItemIndex>-1) then begin
    aTag[FormMain_TagListTag.ItemIndex].sCategory:=FormMain_TagEditCategory.Text;
    aTag[FormMain_TagListTag.ItemIndex].sNameGgs:=FormMain_TagEditGgs.Text;
    aTag[FormMain_TagListTag.ItemIndex].sNameColumn:=FormMain_TagEditColumn.Text;
    FormMain_TagListTag.Items[FormMain_TagListTag.ItemIndex]:=FormMain_TagEditGgs.Text;
    TagNoChange();
    //OnFileChange(); //problem: nevim, v kterem souboru je TAG pouzit/definovan
  end;
end;

procedure InitTag;
begin
  FormMain_TagListCategory.OnClick:=@TagListCategoryOnClick;
  FormMain_TagListTag.OnClick:=@TagListTagOnClick;
  FormMain_TagButCat.OnClick:=@TagButCatOnClick;
  FormMain_TagButAdd.OnClick:=@TagButAddOnClick;
  FormMain_TagButUpdate.OnClick:=@TagButUpdateOnClick;
  FormMain_TagButDel.OnClick:=@TagButDelOnClick;
  FormMain_TagEditGgs.OnChange:=@TagEditGgsOnChange;
  FormMain_TagEditCategory.OnChange:=@TagOnChange;
  FormMain_TagEditColumn.OnChange:=@TagOnChange;
  GetGGTagCategories;
  TagNoChange();
end;
