function GetMainDir:string;
begin
  Result:=Geoget_Scriptdir+'\GgStatTune';
end;

function GetAutoStatDir:string;
begin
  Result:=Geoget_Scriptdir+'\AutoStat';
end;

function GetGgStatDir:string;
begin
  Result:=Geoget_Scriptdir+'\GgStat';
end;

function FindIndexCmdParFromCmd(cmd:string):integer;
var i:integer;
begin
  Result:=-1;
  for i:=0 to naCmdPar-1 do begin
    if(aCmdPar[i].sCommand=cmd) then begin Result:=i; i:=naCmdPar; end;
  end;
end;

function FindIndexCmdParFromTemplate:integer;
begin
  Result:=-1;
  if(FormMain_UvodListTemplate.ItemIndex>-1) then begin
    Result:=aIndexCommand[FormMain_UvodListTemplate.ItemIndex];
    Result:=aCommand[Result].iCmdPar;
  end;
end;

function FindIndexCmdParFromMozne:integer;
var s:string;
begin
  Result:=-1;
  if(FormMain_UvodListMozne.ItemIndex>-1) then begin
    s:=FormMain_UvodListMozne.Items[FormMain_UvodListMozne.ItemIndex];
    Result:=FindIndexCmdParFromCmd(fetch(s,CMT_SEPARATOR));
  end;
end;
// -------- prace se zalozkami -------------------------------------------
procedure EnableMainButtons;
begin
  FormMain_MainButSave.Enabled:=(FormMain_MainCheckChange.Checked) and (FormMain_Pages.ActivePage.Name='TabUvod');
  FormMain_MainButSaveAs.Enabled:=(FormMain_Pages.ActivePage.Name='TabUvod');
  FormMain_MainButPreview.Enabled:=(FormMain_Pages.ActivePage.Name='TabUvod');
  FormMain_MainButExit.Enabled:=(FormMain_Pages.ActivePage.Name='TabUvod');
end;

procedure ShowPage(Ctrl:TPageControl;sName:string);
var i,j:integer;
    tab:TTabSheet;
begin
  j:=-1;
  tab:=ctrl.ActivePage;
  for i:=0 to ctrl.PageCount-1 do begin //o jednou vic, aby se proslo opravdu vsemi zalozkami
    //pokud je to pozadovana nebo vzdy viditelna zalozka
    //pri editaci je viditelna jen editacni, v ostatnich pripadech i zalozky pro
    //nastaveni skupinovych prikazu (ale ne editacni)
    if(tab.Name=sName) or
      ((sName<>'TabEdit') and
       ((tab.Name='TabTag') or (tab.Name='TabNumbers') or (tab.Name='TabColorset')
          {or (tab.Name='TabTable') or (tab.Name='TabGraph')or (tab.Name='TabMap')}
          )) then begin
      tab.TabVisible:=true;
      if(tab.Name=sName) then j:=i;
    end
    else tab.TabVisible:=false;
    //2. parametr true ... nasledujici stranka, false ... predchozi
    //3. parametr true ... bere v uvahu jen visible stranky
    tab:=ctrl.FindNextPage(tab,false,false);
  end;
  if(j=-1) then ShowMessage('ERROR: Nenalezena zalozka '+sName)
  else while (ctrl.ActivePage.Name<>sName) do ctrl.SelectNextPage(true,true);
  EnableMainButtons();
end;

// -------- prace s barevnymi sadami -------------------------------------------
function ColorsetFindByColors(sColors:string):Integer;
var i:Integer;
begin
  Result:=-1;
  for i:=0 to naColorset-1 do begin
    if(aColorset[i].sColors=sColors) then begin Result:=i; i:=naColorset-1; end;
  end;
end;

function ColorsetFindByName(sName:string):Integer;
var i:Integer;
begin
  Result:=-1;
  for i:=0 to naColorset-1 do begin
    if(aColorset[i].sName=sName) then begin Result:=i; i:=naColorset-1; end;
  end;
end;

function ColorsetAdd(sName,sColors:string):string;
begin
  Result:=sName;
  if(naColorset>=MAX_COLORSET) then ShowMessage('ERROR: pekroen poet barevnch sad')
  else begin
    if(sName='') then Result:='Nepojmenovane_'+IntToStr(naColorset+1);
    aColorset[naColorset].sName:=Result;
    aColorset[naColorset].sColors:=sColors;
    naColorset:=naColorset+1;
  end;
end;

function ColorsetSave(sColors:string):string;//ulozi barevnou sadu, vraci jeji jmeno
var i:integer;
    s,s1:string;
    a:TStringList;
begin
  s:=Trim(sColors);
  s:=RegexReplace('\s+',s,CRLF,false); //oddelime parametry novym radkem
  //separujeme polozky, zjistime jmeno, pokud existuje
  a:=TStringList.Create();
  s1:=s;
  while (s1<>'') do begin a.Add(fetch(s1,CRLF)); end;
  //pokud se nejedna primo o definici, zkontrolujeme, zda uz stejne barvy nejsou ulozeny
  if(a.Count=14) then begin //jsou to jen barvy, bez jmena
    i:=ColorsetFindByColors(s);
    if(i<0) then Result:=ColorsetAdd('',s) //pokud neni, nemusime pridavat, vratime jmeno
    else Result:=aColorset[i].sName;
  end
  else begin
    Result:=fetch(s,CRLF); //nacteme jmeno
    fetch(s,CRLF);         //preskocime 'COLORS'
    ColorsetAdd(Result,s);
  end;
  a.Free();
end;

procedure OnFileChange;
begin
  FormMain_MainCheckChange.checked:=true;
  if(not aFiles[FormMain_MainListFiles.ItemIndex].bChange) then begin
    aFiles[FormMain_MainListFiles.ItemIndex].bChange:=true;
    FormMain_MainListFiles.Invalidate; //vynutime prekreselni seznamu
  end;
  FormMain_MainButSave.Enabled:=true;
end;

procedure SetProgressBar(min,max:integer;text:string);
begin
  FormMain_MainLabelProgress.Caption:=text;
  FormMain_MainLabelProgress.Repaint;
  FormMain_MainProgress.Min:=min;
  FormMain_MainProgress.Max:=max;
  FormMain_MainProgress.Position:=min;
end;
